> For the complete documentation index, see [llms.txt](https://docs.hesh.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hesh.app/manuals/public-api/clients.md).

# Clients

## Create clients in batch

> This method allows you to create one or more clients at the same time.

```json
{"openapi":"3.0.0","info":{"title":"Public API","version":"1.0"},"tags":[{"name":"Clients"}],"servers":[{"url":"https://api-stage.hesh.tech"}],"security":[{"PublicApiKey":[]}],"components":{"securitySchemes":{"PublicApiKey":{"type":"apiKey","in":"header","name":"x-api-key"}},"schemas":{"PublicClientUpsertDto":{"type":"object","properties":{"clients":{"type":"array","items":{"$ref":"#/components/schemas/PublicClientCreateDto"}}},"required":["clients"]},"PublicClientCreateDto":{"type":"object","properties":{"name":{"type":"string","description":"Client name"},"external_client_id":{"type":"string","description":"External client identifier"},"phone":{"type":"string","nullable":true,"description":"Client's phone number"},"email":{"type":"string","nullable":true,"description":"Client's email"},"company":{"type":"string","nullable":true,"description":"Client's company name"}},"required":["name","external_client_id"]},"PublicClientResponseDto":{"type":"object","properties":{"id":{"type":"string","description":"Unique identifier of the created client"},"external_client_id":{"type":"string","nullable":true,"description":"External client identifier"},"name":{"type":"string","description":"Client name"},"phone":{"type":"string","nullable":true,"description":"Client's phone number"},"email":{"type":"string","nullable":true,"description":"Client's email"},"company":{"type":"string","nullable":true,"description":"Client's company name"}},"required":["id","external_client_id","name","phone","email","company"]}}},"paths":{"/api/v1/public/clients/batch":{"post":{"description":"This method allows you to create one or more clients at the same time.","operationId":"PublicClientsController_upsertClients_v1","parameters":[{"name":"x-tenant-id","in":"header","description":"Tenant id (uuid v4)","required":false,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PublicClientUpsertDto"}}}},"responses":{"201":{"description":"","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PublicClientResponseDto"}}}}},"429":{"description":"Returned when the rate limit is exceeded","headers":{"X-RateLimit-Limit":{"description":"Maximum number of allowed requests during the current window","schema":{"type":"integer"}},"X-RateLimit-Remaining":{"description":"Remaining number of requests before throttling occurs","schema":{"type":"integer"}},"X-RateLimit-Reset":{"description":"Number of seconds until the rate limit window resets","schema":{"type":"integer"}}}}},"summary":"Create clients in batch","tags":["Clients"]}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hesh.app/manuals/public-api/clients.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
